from genetic_algorithm import *
from local_search import local_search


def run_local_search(n, m, data, individual):
    pass


def memetic_algorithm(n, m, data, hybridation, max_iterations=100000):
    population = [generate_individual(n, m, data) for _ in range(n)]
    population = evaluate_population(population, data)
    for i in range(max_iterations):
        if i % 10 == 0:
            best_index, _ = get_best_elements(population)
            run_local_search(n, m, data, individual=population[best_index])
        parents = select_parents(population, n, mode="stationary")
        offspring = crossover(mode="uniform", parents=parents, m=m)
        offspring = mutate(offspring, n, data)
        population = replace_population(population, offspring, mode="stationary")
        population = evaluate_population(population, data)
    best_index, _ = get_best_elements(population)
    return population[best_index]
